import time
import board
import busio
import rtc
import displayio
import fourwire
import digitalio
import terminalio
from adafruit_display_text import label
from adafruit_display_shapes.rect import Rect
from adafruit_display_shapes.circle import Circle
import adafruit_displayio_sh1106
import pwmio

# Compatibility with both CircuitPython 8.x.x and 9.x.x.
# Remove after 8.x.x is no longer a supported release.
try:
    from fourwire import FourWire
except ImportError:
    from displayio import FourWire

#DC = board.GP8
#Reset = board.GP9
#CS = board.GP10
#SCK = board.GP18
#MOSI = board.GP19

# built-in a display
displayio.release_displays()
# Make the displayio SPI bus and the sh1106 display
spi = busio.SPI(board.GP18, board.GP19)
#
# Circuit 8.x.x
#display_bus = displayio.FourWire(spi, command=board.GP8, chip_select=board.GP10, reset=board.GP9, baudrate=1000000)
#display =adafruit_displayio_sh1106.SH1106(display_bus, width=132, height=64, rotation=0, brightness = 1)
#
# Circuit 9.x.x
display_bus = FourWire(spi, command=board.GP8, chip_select=board.GP10, reset=board.GP9, baudrate=1000000)
display =adafruit_displayio_sh1106.SH1106(display_bus, width=132, height=64, rotation=0, brightness = 1)

# Make the display contexts
splash = displayio.Group()
display.root_group = splash
setup = displayio.Group()
display.root_group = setup
set_hour_min = displayio.Group()
display.root_group = set_hour_min
set_datum = displayio.Group()
display.root_group = set_datum

#rote LED
#led_red = digitalio.DigitalInOut(board.GP5)
#led_red.direction = digitalio.Direction.OUTPUT
led_red = pwmio.PWMOut(board.GP5)
speaker = pwmio.PWMOut(board.GP15)
#gelbe LED
led_yellow = digitalio.DigitalInOut(board.GP6)
led_yellow.direction = digitalio.Direction.OUTPUT
#grüne LED
led_green = digitalio.DigitalInOut(board.GP7)
led_green.direction = digitalio.Direction.OUTPUT

## Joystick
#JOY_UP = GP1
up = digitalio.DigitalInOut(board.GP1)
up.direction = digitalio.Direction.INPUT
up.pull = digitalio.Pull.UP
#JOY_DOWN = GP3
down = digitalio.DigitalInOut(board.GP3)
down.direction = digitalio.Direction.INPUT
down.pull = digitalio.Pull.UP
#JOY_LEFT = GP4
left = digitalio.DigitalInOut(board.GP4)
left.direction = digitalio.Direction.INPUT
left.pull = digitalio.Pull.UP
#JOY_RIGHT = GP2
right = digitalio.DigitalInOut(board.GP2)
right.direction = digitalio.Direction.INPUT
right.pull = digitalio.Pull.UP
#JOY_CENTER = GP0
center = digitalio.DigitalInOut(board.GP0)
center.direction = digitalio.Direction.INPUT
center.pull = digitalio.Pull.UP

zeit = "00:00:00"
wotage = ["Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag", "Sonntag"]
alarm = [6,0]
option = 1

# create the label
updating_zeit = label.Label(font=terminalio.FONT, text="", scale=2, color=0xffffff, line_spacing=1)
# set label position on the display
updating_zeit.anchor_point = (0, 0)
updating_zeit.anchored_position = (15, 20)
# add label to group that is showing on display
splash.append(updating_zeit)

updating_label = label.Label(font=terminalio.FONT, text="", scale=1, color=0xffffff, line_spacing=1)
updating_label.anchor_point = (0, 0)
updating_label.anchored_position = (45, 3)
splash.append(updating_label)

updating_setup = label.Label(font=terminalio.FONT, text="Uhr stellen\n     Uhrzeit\n     Datum\n     Alarm\n     Exit", scale=1, color=0xffffff, line_spacing=1)
updating_setup.anchor_point = (0, 0)
updating_setup.anchored_position = (30, 0)
setup.append(updating_setup)

circle_auswahl = Circle(50, 17, 3, fill=0xffff00, outline=0x000000 )
setup.append(circle_auswahl)

# Stunde und Minute stellen
updating_stunde_minute = label.Label(font=terminalio.FONT, text="00:00:00", scale=2, color=0xffffff, line_spacing=1)
updating_stunde_minute.anchor_point = (0, 0)
updating_stunde_minute.anchored_position = (15, 20)
set_hour_min.append(updating_stunde_minute)

# Datum stellen
updating_datum = label.Label(font=terminalio.FONT, text="01:01:2024", scale=1, color=0xffffff, line_spacing=1)
updating_datum.anchor_point = (0, 0)
updating_datum.anchored_position = (45, 25)
set_datum.append(updating_datum)

def Datum_stellen(year, month, day, hour, minute, tag):
    display.root_group = set_datum
    while True:
        if up.value == False:
            day += 1
            if day == 32:
                day = 1
        if down.value == False:
            day -= 1
            if day == -1:
                day = 31
        if right.value == False:
            month += 1
            if month == 13:
                month = 1
                year +=1
        if left.value == False:
            month -= 1
            if month == -1:
                month = 12
                year -= 1
        time.sleep(0.2)
        # Anzeige von Datum
        if day < 10:
            datum = "0" + str(day) + "."
        else:
            datum = str(day) + "."
        if month < 10:
            datum = datum + "0" + str(month) + "." + str(year)
        else:
            datum = datum + str(month) + "." + str(year)
        updating_datum.text = datum
        if center.value == False:
            r = rtc.RTC()
            r.datetime = time.struct_time((year, month, day, hour, minute, 0, tag, 1, -1))
            time.sleep(0.2)
            display.root_groop = splash
            break

def Uhrzeit_stellen(year, month, day, hour, minute, tag):
    display.root_group = set_hour_min   
    while True:
        if up.value == False:
            hour += 1
            if hour == 24:
                hour = 0
        if down.value == False:
            hour -= 1
            if hour == 0:
                hour = 23
        if right.value == False:
            minute += 1
            if minute == 60:
                minute = 0
        if left.value == False:
            minute -= 1
            if minute == -1:
                minute = 59
        time.sleep(0.2)
        ## Anzeige beim Stellen der Uhr
        if hour < 10:
            zeit = "0" + str(hour)
        else:
            zeit = str(hour)
        if minute < 10:
            zeit = zeit + ":0" + str(minute) + ":00"
        else:
            zeit = zeit + ":" + str(minute) + ":00"
        updating_stunde_minute.text = zeit
        if center.value == False:
            r = rtc.RTC()
            r.datetime = time.struct_time((year, month, day, hour, minute, 0, tag, 1, -1))
            time.sleep(0.2)
            display.root_groop = splash
            break

def Alarmzeit_stellen(a_hour, a_minute):
    display.root_group = set_hour_min   
    while True:
        if up.value == False:
            a_hour += 1
            if a_hour == 24:
                a_hour = 0
        if down.value == False:
            a_hour -= 1
            if a_hour == 0:
                a_hour = 23
        if right.value == False:
            a_minute += 1
            if a_minute == 60:
                a_minute = 0
        if left.value == False:
            a_minute -= 1
            if a_minute == -1:
                a_minute = 59
        time.sleep(0.2)
        ## Anzeige beim Stellen der Uhr
        if a_hour < 10:
            zeit = "0" + str(a_hour)
        else:
            zeit = str(a_hour)
        if a_minute < 10:
            zeit = zeit + ":0" + str(a_minute)
        else:
            zeit = zeit + ":" + str(a_minute)
        updating_stunde_minute.text = zeit
        if center.value == False:
            alarm[0] = a_hour
            alarm[1] = a_minute
            display.root_groop = splash
            led_green.value = True
            break
  
current_time = time.localtime()
hour = current_time.tm_hour
minute = current_time.tm_min
second = current_time.tm_sec
year = current_time.tm_year
month = current_time.tm_mon
day = current_time.tm_mday
tag = current_time.tm_wday
datum = str(day) + "." + str(month) + "." + str(year)
if current_time.tm_year > 2020:
    stellen = 0
if current_time.tm_year == 2020:
    year = 2024
    stellen = 1

while True:
    if stellen == 0:
        display.root_group = splash
        current_time = time.localtime()
        hour = current_time.tm_hour
        minute = current_time.tm_min
        second = current_time.tm_sec
        year = current_time.tm_year
        month = current_time.tm_mon
        day = current_time.tm_mday
        tag = current_time.tm_wday
        datum = str(day) + "." + str(month) + "." + str(year)
    if stellen == 1:
        display.root_group = setup
        if (down.value) == False:
            circle_auswahl.fill = 0x000000
            circle_auswahl.y = circle_auswahl.y + 12
            time.sleep(0.4)
            circle_auswahl.fill = 0xffff00
            if option < 5:
                option +=1
            if option == 5:
                circle_auswahl.y = 15
                option = 1
        if up.value == False:
            circle_auswahl.fill = 0x000000
            circle_auswahl.y = circle_auswahl.y - 12
            time.sleep(0.4)
            circle_auswahl.fill = 0xffff00
            if option > 0:
                option -=1
            if option == 0:
                circle_auswahl.y = 51
                option = 4
        if center.value == False:
            time.sleep(0.4)
            if option == 1:
                Uhrzeit_stellen(year, month, day, hour, minute, tag)
                stellen = 0
            if option == 2:
                Datum_stellen(year, month, day, hour, minute, tag)
                stellen = 0
            if option == 3:
                a_hour = alarm[0]
                a_minute = alarm[1]
                Alarmzeit_stellen(a_hour, a_minute)
                stellen = 0
                display.root_groop = splash
            if option == 4:
                stellen = 0
                option = 1
                display.root_groop = splash
    if center.value == False and stellen == 0:
        stellen = 1
        time.sleep(0.6)
    if hour < 10:
        zeit = "0" + str(hour)
    else:
        zeit = str(hour)
    if minute < 10:
        zeit = zeit + ":0" + str(minute)
    else:
        zeit = zeit + ":" + str(minute)
    if second < 10:
        zeit = zeit + ":0" + str(second)
    else:
        zeit = zeit + ":" + str(second)
    ## Wochentag, Datum und Zeit anzeigen
    updating_zeit.text = zeit
    updating_label.text = wotage[tag] + "\n\n\n\n" + datum
    if alarm[0] == hour and alarm[1] == minute:
        led_green.value = False
        for cycle in range(0, 65535, +2):  # Cycles through the full PWM range from 0 to 65535
            led_red.duty_cycle = cycle  # Cycles the LED pin duty cycle through the range of values
            speaker.duty_cycle = 32678
        for cycle in range(65534, 0, -2):  # Cycles through the PWM range backwards from 65534 to 0
            led_red.duty_cycle = cycle  # Cycles the LED pin duty cycle through the range of values
            speaker.duty_cycle = 0
            